
//===============Followig code needs to be loaded into Arduino====================


String inputString = "";         // a string to hold incoming data
boolean stringComplete = false;  // whether the string is complete
const int LEDPin = 10;

const int tempSensorPin = A0;
const int ledSensorPin = A1;
const int tiltSensorPin = 8;


int LEDValue = 50;
int ledSensorValue = 0;
int tempSensorValue = 0;
int tiltSensorValue = 0;

void setup()
{
       Serial.begin(921600);
  /* add setup code here */
       pinMode(LEDPin, OUTPUT);
       pinMode(tiltSensorPin, INPUT);
       analogWrite(LEDPin,LEDValue);
}

void loop()
{
       if (stringComplete) {
              analogWrite(LEDPin, LEDValue);
              ledSensorValue = analogRead(ledSensorPin);
              Serial.println(ledSensorValue);
              tempSensorValue = analogRead(tempSensorPin);
              Serial.println(tempSensorValue);
              tiltSensorValue = digitalRead(tiltSensorPin);
              Serial.println(tiltSensorValue);
              stringComplete = false;
       }
}

void serialEvent() {
       while (Serial.available() > 0) {
              // get the new byte:
              char inChar = (char)Serial.read();
              if (isDigit(inChar)) {
                     inputString += inChar;
              }
              
              // if the incoming character is a newline, set a flag
              // so the main loop can do something about it:
              if (inChar == '\n') {
                     LEDValue=(inputString.toInt());
                     stringComplete = true;
                     inputString = "";
              }
       }
}

